Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavgam.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavgam.F90	(revision 11423)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavgam.F90	(revision 11423)
@@ -0,0 +1,231 @@
+MODULE isfcavgam
+   !!======================================================================
+   !!                       ***  MODULE  isfgammats  ***
+   !! Ice shelf module :  compute exchange coeficient at the ice/ocean interface
+   !!======================================================================
+   !! History :  4.1  !  (P. Mathiot) original
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   isf_gammats       : compute exchange coeficient gamma 
+   !!----------------------------------------------------------------------
+   USE oce            ! ocean dynamics and tracers
+   USE isf
+   USE isftbl
+   USE dom_oce        ! ocean space and time domain
+   USE phycst         ! physical constants
+   USE eosbn2         ! equation of state
+   USE zdfdrg         ! vertical physics: top/bottom drag coef.
+   USE iom
+   USE in_out_manager ! I/O manager
+   !
+   IMPLICIT NONE
+   !
+   PRIVATE
+   !
+   PUBLIC   isfcav_gammats
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OCE 4.0 , NEMO Consortium (2018)
+   !! $Id: sbcisf.F90 10536 2019-01-16 19:21:09Z mathiot $
+   !! Software governed by the CeCILL license (see ./LICENSE)
+   !!----------------------------------------------------------------------
+CONTAINS
+   !
+   !!-----------------------------------------------------------------------------------------------------
+   !!                              PUBLIC SUBROUTINES 
+   !!-----------------------------------------------------------------------------------------------------
+   !
+   SUBROUTINE isfcav_gammats( pttbl, pstbl, pqoce, pqfwf, pgt, pgs )
+      !!----------------------------------------------------------------------
+      !! ** Purpose    : compute the coefficient echange for heat and fwf flux
+      !!
+      !! ** Method     : select the gamma formulation
+      !!                 3 method available (cst, AD15 and HJ99)
+      !!---------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pgt  , pgs      ! gamma t and gamma s 
+      !!-------------------------- IN  -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pqoce, pqfwf    ! isf heat and fwf
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pttbl, pstbl    ! top boundary layer tracer
+      !!---------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)                :: zutbl, zvtbl    ! top boundary layer velocity
+      !!---------------------------------------------------------------------
+      !
+      ! compute velocity in the tbl if needed
+      SELECT CASE ( cn_gammablk )
+      CASE ( 'spe'  ) 
+         ! gamma is constant (specified in namelist)
+         ! nothing to do
+      CASE ('ad15', 'hj99')
+         CALL isf_tbl(un(:,:,:) ,zutbl(:,:),'U')
+         CALL isf_tbl(vn(:,:,:) ,zvtbl(:,:),'V')
+         CALL iom_put('utbl',zutbl(:,:))
+         CALL iom_put('vtbl',zvtbl(:,:))
+      CASE DEFAULT
+         CALL ctl_stop('STOP','method to compute gamma (cn_gammablk) is unknown (should not see this)')
+      END SELECT
+      ! 
+      ! compute gamma
+      SELECT CASE ( cn_gammablk )
+      CASE ( 'spe'  ) ! gamma is constant (specified in namelist)
+         pgt(:,:) = rn_gammat0
+         pgs(:,:) = rn_gammas0
+      CASE ( 'ad15' ) ! gamma is proportional to u*
+         CALL gammats_AD15 (              zutbl, zvtbl, rCdU_top, r_ke0_top,               pgt, pgs )
+      CASE ( 'hj99' ) ! gamma depends of stability of boundary layer and u*
+         CALL gammats_HJ99 (pttbl, pstbl, zutbl, zvtbl, rCdU_top, r_ke0_top, pqoce, pqfwf, pgt, pgs )
+      CASE DEFAULT
+         CALL ctl_stop('STOP','method to compute gamma (cn_gammablk) is unknown (should not see this)')
+      END SELECT
+      !
+      ! ouput exchange coeficient and tbl velocity
+      CALL iom_put('isfgammat', pgt(:,:))
+      CALL iom_put('isfgammas', pgs(:,:))
+      !
+   END SUBROUTINE isfcav_gammats
+   !
+   !!-----------------------------------------------------------------------------------------------------
+   !!                              PRIVATE SUBROUTINES 
+   !!-----------------------------------------------------------------------------------------------------
+   !
+   SUBROUTINE gammats_AD15(putbl, pvtbl, pCd, pke2, &   ! <<== in
+      &                                  pgt, pgs   )   ! ==>> out gammats [m/s]
+      !!----------------------------------------------------------------------
+      !! ** Purpose    : compute the coefficient echange coefficient 
+      !!
+      !! ** Method     : gamma is velocity dependent ( gt= gt0 * Ustar )
+      !!
+      !! ** Reference  : Jenkins et al., 2010, JPO, p2298-2312
+      !!                 Asay-Davis et al., Geosci. Model Dev., 9, 2471-2497, 2016
+      !!---------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pgt, pgs     ! gammat and gammas [m/s]
+      !!-------------------------- IN  -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: putbl, pvtbl ! velocity in the losch top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pCd          ! drag coefficient
+      REAL(wp),                     INTENT(in   ) :: pke2         ! background velocity
+      !!---------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj) :: zustar
+      !!---------------------------------------------------------------------
+      !
+      ! compute ustar (AD15 eq. 27)
+      zustar(:,:) = SQRT( pCd(:,:) * ( putbl(:,:) * putbl(:,:) + pvtbl(:,:) * pvtbl(:,:) + pke2 ) )
+      !
+      ! Compute gammats
+      pgt(:,:) = zustar(:,:) * rn_gammat0
+      pgs(:,:) = zustar(:,:) * rn_gammas0
+      !
+      ! output ustar
+      CALL iom_put('isfustar',zustar(:,:))
+      !
+   END SUBROUTINE gammats_AD15
+
+   SUBROUTINE gammats_HJ99( pttbl, pstbl, putbl, pvtbl, pCd, pke2, pqoce, pqfwf, &  ! <<== in
+      &                                                            pgt  , pgs    )  ! ==>> out gammats [m/s]
+      !!----------------------------------------------------------------------
+      !! ** Purpose    : compute the coefficient echange coefficient 
+      !!
+      !! ** Method     : gamma is velocity dependent and stability dependent
+      !!
+      !! ** Reference  : Holland and Jenkins, 1999, JPO, p1787-1800
+      !!---------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pgt, pgs     ! gammat and gammas
+      !!-------------------------- IN  -------------------------------------
+      REAL(wp),                     INTENT(in   ) :: pke2           ! background velocity squared
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pqoce, pqfwf   ! surface heat flux and fwf flux
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pCd            ! drag coeficient
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: putbl, pvtbl   ! velocity in the losch top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pttbl, pstbl   ! tracer   in the losch top boundary layer
+      !!---------------------------------------------------------------------
+      INTEGER  :: ji, jj                     ! loop index
+      INTEGER  :: ikt                        ! local integer
+      REAL(wp) :: zdku, zdkv                 ! U, V shear 
+      REAL(wp) :: zPr, zSc, zRc              ! Prandtl, Scmidth and Richardson number 
+      REAL(wp) :: zmob, zmols                ! Monin Obukov length, coriolis factor at T point
+      REAL(wp) :: zbuofdep, zhnu             ! Bouyancy length scale, sublayer tickness
+      REAL(wp) :: zhmax                      ! limitation of mol
+      REAL(wp) :: zetastar                   ! stability parameter
+      REAL(wp) :: zgmolet, zgmoles, zgturb   ! contribution of modelecular sublayer and turbulence 
+      REAL(wp) :: zcoef                      ! temporary coef
+      REAL(wp) :: zdep
+      REAL(wp) :: zeps = 1.0e-20_wp    
+      REAL(wp), PARAMETER :: zxsiN = 0.052_wp   ! dimensionless constant
+      REAL(wp), PARAMETER :: znu   = 1.95e-6_wp ! kinamatic viscosity of sea water (m2.s-1)
+      REAL(wp), DIMENSION(2) :: zts, zab
+      REAL(wp), DIMENSION(jpi,jpj) :: zustar    ! friction velocity
+      !!---------------------------------------------------------------------
+      !
+      ! compute ustar
+      zustar(:,:) = SQRT( pCd * ( putbl(:,:) * putbl(:,:) + pvtbl(:,:) * pvtbl(:,:) + r_ke0_top ) )
+      !
+      ! output ustar
+      CALL iom_put('isfustar',zustar(:,:))
+      !
+      ! compute Pr and Sc number (eq ??)
+      zPr =   13.8_wp
+      zSc = 2432.0_wp
+      !
+      ! compute gamma mole (eq ??)
+      zgmolet = 12.5_wp * zPr ** (2.0/3.0) - 6.0_wp
+      zgmoles = 12.5_wp * zSc ** (2.0/3.0) - 6.0_wp
+      !
+      ! compute gamma
+      DO ji = 2, jpi
+         DO jj = 2, jpj
+            ikt = mikt(ji,jj)
+
+            IF( zustar(ji,jj) == 0._wp ) THEN           ! only for kt = 1 I think
+               pgt = rn_gammat0
+               pgs = rn_gammas0
+            ELSE
+               ! compute Rc number (as done in zdfric.F90)
+!!gm better to do it like in the new zdfric.F90   i.e. avm weighted Ri computation
+               zcoef = 0.5_wp / e3w_n(ji,jj,ikt+1)
+               !                                            ! shear of horizontal velocity
+               zdku = zcoef * (  un(ji-1,jj  ,ikt  ) + un(ji,jj,ikt  )  &
+                  &             -un(ji-1,jj  ,ikt+1) - un(ji,jj,ikt+1)  )
+               zdkv = zcoef * (  vn(ji  ,jj-1,ikt  ) + vn(ji,jj,ikt  )  &
+                  &             -vn(ji  ,jj-1,ikt+1) - vn(ji,jj,ikt+1)  )
+               !                                            ! richardson number (minimum value set to zero)
+               zRc = MAX(rn2(ji,jj,ikt+1), 0._wp) / MAX( zdku*zdku + zdkv*zdkv, zeps )
+
+               ! compute bouyancy 
+               zts(jp_tem) = pttbl(ji,jj)
+               zts(jp_sal) = pstbl(ji,jj)
+               zdep        = gdepw_n(ji,jj,ikt)
+               !
+               CALL eos_rab( zts, zdep, zab )
+               !
+               ! compute length scale (Eq ??)
+               zbuofdep = grav * ( zab(jp_tem) * pqoce(ji,jj) - zab(jp_sal) * pqfwf(ji,jj) )
+               !
+               ! compute Monin Obukov Length
+               ! Maximum boundary layer depth (Eq ??)
+               zhmax = gdept_n(ji,jj,mbkt(ji,jj)) - gdepw_n(ji,jj,mikt(ji,jj)) -0.001_wp
+               !
+               ! Compute Monin obukhov length scale at the surface and Ekman depth: (Eq ??)
+               zmob   = zustar(ji,jj) ** 3 / (vkarmn * (zbuofdep + zeps))
+               zmols  = SIGN(1._wp, zmob) * MIN(ABS(zmob), zhmax) * tmask(ji,jj,ikt)
+               !
+               ! compute eta* (stability parameter) (Eq ??)
+               zetastar = 1._wp / ( SQRT(1._wp + MAX(zxsiN * zustar(ji,jj) / ( ABS(ff_f(ji,jj)) * zmols * zRc ), 0._wp)))
+               !
+               ! compute the sublayer thickness (Eq ??)
+               zhnu = 5 * znu / zustar(ji,jj)
+               !
+               ! compute gamma turb (Eq ??)
+               zgturb = 1._wp / vkarmn * LOG(zustar(ji,jj) * zxsiN * zetastar * zetastar / ( ABS(ff_f(ji,jj)) * zhnu )) &
+               &      + 1._wp / ( 2 * zxsiN * zetastar ) - 1._wp / vkarmn
+               !
+               ! compute gammats
+               pgt(ji,jj) = zustar(ji,jj) / (zgturb + zgmolet)
+               pgs(ji,jj) = zustar(ji,jj) / (zgturb + zgmoles)
+            END IF
+         END DO
+      END DO
+
+   END SUBROUTINE gammats_HJ99
+
+END MODULE isfcavgam
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90	(revision 11423)
@@ -198,5 +198,5 @@
             ! solve the 2nd order equation to find zsfrz
             zaqe  = risf_lamb1 * (zeps1 + zeps3)
-            zaqer = 0.5_wp/MIN(zaqe,-risf_eps)
+            zaqer = 0.5_wp/MIN(zaqe,-zeps)
             zbqe  = zeps1*zeps6+zeps3*zeps7-zeps2
             zcqe  = zeps2*pstbl(ji,jj)
@@ -248,5 +248,5 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pstbl               ! salinity in tbl
       !!--------------------------------------------------------------------
-      REAL(wp)                     :: zfwf_fld, zfwf_cpl                 ! total fwf in the forcing fields (pattern) and from the cpl interface (amount)
+      REAL(wp)                     :: zfwf_fld, zfwf_oasis               ! total fwf in the forcing fields (pattern) and from the oasis interface (amount)
       REAL(wp), DIMENSION(jpi,jpj) :: ztfrz                              ! tbl freezing temperature
       REAL(wp), DIMENSION(jpi,jpj) :: zfwf                               ! 2d fwf map after scaling
@@ -266,8 +266,8 @@
       !
       ! compute glob sum from atm->oce ice shelf fwf
-      zfwf_cpl = glob_sum('isfcav_mlt', fwfisf_cpl(:,:))
+      zfwf_oasis = glob_sum('isfcav_mlt', fwfisf_oasis(:,:))
       !
       ! scale fwf
-      zfwf(:,:) = zfwf(:,:) * zfwf_cpl / zfwf_fld
+      zfwf(:,:) = zfwf(:,:) * zfwf_oasis / zfwf_fld
       ! 
       ! define fwf and qoce
@@ -281,4 +281,5 @@
    !SUBROUTINE isfmlt_3eq_frz_ktm1
    ! compute tfrz based on sfrz value at kt-1 (need to be SAVED local array)
+   ! => should reduce error due to linarisation
    ! compute qfwf (eq 24)
    ! compute zqoce, zqlat, zqcon, zqhc
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfhdiv.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfhdiv.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfhdiv.F90	(revision 11423)
@@ -4,4 +4,5 @@
    USE isf
    USE phycst
+   USE in_out_manager
 
    IMPLICIT NONE
@@ -13,5 +14,5 @@
 CONTAINS
 
-   SUBROUTINE isf_hdiv( phdiv )
+   SUBROUTINE isf_hdiv( kt, phdiv )
       !!----------------------------------------------------------------------
       !!                  ***  SUBROUTINE isf_hdiv  ***
@@ -25,4 +26,5 @@
       REAL(wp), DIMENSION(:,:,:), INTENT( inout ) ::   phdiv   ! horizontal divergence
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: kt
       !
       ! ice shelf cavity contribution
@@ -33,5 +35,13 @@
       !
       ! ice sheet coupling contribution (if conservation needed)
-      !IF ( ln_iscpl_hsb  ) CALL isf_hdiv_cpl(hdiv_iscpl, phdivn)
+      IF ( ll_isfcpl ) THEN
+         !
+         ! correct divergence only for the first time step
+         IF ( kt == nit000 ) CALL isf_hdiv_cpl(risfcpl_vol, phdiv)
+         !
+         ! correct divergence every time step to remove any trend due to coupling
+         IF ( ll_isfcpl_cons ) CALL isf_hdiv_cpl(risfcpl_cons_vol, phdiv)
+         !
+      END IF
       !
    END SUBROUTINE isf_hdiv
@@ -81,3 +91,15 @@
    END SUBROUTINE isf_hdiv_mlt
 
+   SUBROUTINE isf_hdiv_cpl(pqvol, phdiv)
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) :: phdiv
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pqvol
+   
+   INTEGER :: jk
+      
+      DO jk=1,jpk 
+         phdiv(:,:,jk) =  phdiv(:,:,jk) + pqvol(:,:,jk) * r1_e1e2t(:,:) / e3t_n(:,:,jk)
+      END DO
+
+   END SUBROUTINE
+
 END MODULE isfhdiv
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfload.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfload.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfload.F90	(revision 11423)
@@ -90,26 +90,26 @@
       !
       !                                !- Surface value + ice shelf gradient
-      risfload = 0._wp                       ! compute pressure due to ice shelf load 
+      risfload(:,:) = 0._wp                       ! compute pressure due to ice shelf load 
       DO jj = 1, jpj                         ! (used to compute hpgi/j for all the level from 1 to miku/v)
          DO ji = 1, jpi                      ! divided by 2 later
             ikt = mikt(ji,jj)
             !
-            ! top layer of the ice shelf
-            risfload(ji,jj) = risfload(ji,jj) + (znad + zrhd(ji,jj,1) ) * e3w_n(ji,jj,1)
-            !
-            ! core layers of the ice shelf
-            DO jk = 2, ikt-1
-               risfload(ji,jj) = risfload(ji,jj) + (2._wp * znad + zrhd(ji,jj,jk-1) + zrhd(ji,jj,jk)) * e3w_n(ji,jj,jk)
-            END DO
-            !
-            ! deepest part of the ice shelf (between deepest T point and ice/ocean interface
-            risfload(ji,jj) = risfload(ji,jj) + (2._wp * znad + zrhdtop_isf(ji,jj) + zrhd(ji,jj,ikt-1)) &
-               &                                              * ( risfdep(ji,jj) - gdept_n(ji,jj,ikt-1) )
-            !
+            IF ( ikt > 1 ) THEN
+               !
+               ! top layer of the ice shelf
+               risfload(ji,jj) = risfload(ji,jj) + (znad + zrhd(ji,jj,1) ) * e3w_n(ji,jj,1)
+               !
+               ! core layers of the ice shelf
+               DO jk = 2, ikt-1
+                  risfload(ji,jj) = risfload(ji,jj) + (2._wp * znad + zrhd(ji,jj,jk-1) + zrhd(ji,jj,jk)) * e3w_n(ji,jj,jk)
+               END DO
+               !
+               ! deepest part of the ice shelf (between deepest T point and ice/ocean interface
+               risfload(ji,jj) = risfload(ji,jj) + (2._wp * znad + zrhdtop_isf(ji,jj) + zrhd(ji,jj,ikt-1)) &
+                  &                                              * ( risfdep(ji,jj) - gdept_n(ji,jj,ikt-1) )
+               !
+            END IF
          END DO
       END DO
-      !
-      ! mask it 
-      risfload(:,:) = risfload(:,:) * mskisf_cav(:,:)  ! need to be saved for diaar5
       !
    END SUBROUTINE isf_load_isomip
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfpar.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfpar.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfpar.F90	(revision 11423)
@@ -146,5 +146,5 @@
          ALLOCATE( sf_isfpar_fwf(1), STAT=ierr )
          ALLOCATE( sf_isfpar_fwf(1)%fnow(jpi,jpj,1), sf_isfpar_fwf(1)%fdta(jpi,jpj,1,2) )
-         CALL fld_fill( sf_isfpar_fwf, (/ sn_isfpar_fwf /), cn_dirisf, 'isf_par_init', 'read fresh water flux isf data', 'namisf' )
+         CALL fld_fill( sf_isfpar_fwf, (/ sn_isfpar_fwf /), cn_isfdir, 'isf_par_init', 'read fresh water flux isf data', 'namisf' )
 
          IF(lwp) WRITE(numout,*)
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90	(revision 11423)
@@ -162,5 +162,5 @@
       !!
       !! ** Purpose    : - read ice shelf melt from forcing file => pattern
-      !!                 - total amount of fwf is given by sbccpl (fwfisf_cpl)
+      !!                 - total amount of fwf is given by sbccpl (fwfisf_oasis)
       !!                 - scale fwf and compute heat fluxes
       !!
@@ -172,5 +172,5 @@
       !!--------------------------------------------------------------------
       INTEGER                           :: jk                            ! loop index
-      REAL(wp)                          :: zfwf_fld, zfwf_cpl            ! total fwf in the forcing fields (pattern) and from the cpl interface (amount)
+      REAL(wp)                          :: zfwf_fld, zfwf_oasis            ! total fwf in the forcing fields (pattern) and from the cpl interface (amount)
       REAL(wp), DIMENSION(jpi,jpj)      :: ztfrz                         ! tbl freezing temperature
       REAL(wp), DIMENSION(jpi,jpj)      :: zfwf                          ! 2d fwf map after scaling
@@ -195,8 +195,8 @@
       !
       ! compute glob sum from atm->oce ice shelf fwf
-      zfwf_cpl = glob_sum('isfcav_mlt', fwfisf_cpl(:,:))
+      zfwf_oasis = glob_sum('isfcav_mlt', fwfisf_oasis(:,:))
       !
       ! scale fwf
-      zfwf(:,:) = zfwf(:,:) * zfwf_cpl / zfwf_fld
+      zfwf(:,:) = zfwf(:,:) * zfwf_oasis / zfwf_fld
       ! 
       ! define fwf and qoce
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90	(revision 11403)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90	(revision 11423)
@@ -31,4 +31,5 @@
    USE isfcav         ! ice shelf cavity
    USE isfload        ! ice shelf load
+   USE isfcpl         ! isf variables
    USE isf            ! isf variables
 
@@ -87,6 +88,6 @@
          ! before time step 
          IF ( kt /= nit000 ) THEN 
-            risf_par_tsc_b (:,:) = risf_par_tsc (:,:)
-            fwfisf_par_b(:,:)    = fwfisf_par(:,:)
+            risf_par_tsc_b(:,:,:) = risf_par_tsc(:,:,:)
+            fwfisf_par_b  (:,:)   = fwfisf_par  (:,:)
          END IF
          !
@@ -100,4 +101,8 @@
          IF (lrst_oce) CALL isfrst_write(kt, 'par', risf_par_tsc, fwfisf_par)
          !
+      END IF
+
+      IF ( ln_isfcpl ) THEN
+         IF (lrst_oce) CALL isfcpl_rst_write(kt)
       END IF
       !
@@ -122,6 +127,8 @@
       INTEGER               :: ji, jj
       !!----------------------------------------------------------------------
-      NAMELIST/namisf/ ln_isfcav_mlt, cn_isfcav_mlt, cn_gammablk, rn_gammat0, rn_gammas0, rn_htbl, sn_isfcav_fwf,  &
-         &             ln_isfpar_mlt, cn_isfpar_mlt, sn_isfpar_fwf, sn_isfpar_zmin, sn_isfpar_zmax, sn_isfpar_Leff
+      NAMELIST/namisf/ ln_isfcav_mlt, cn_isfcav_mlt, cn_gammablk, rn_gammat0, rn_gammas0, rn_htbl, sn_isfcav_fwf,   &
+         &             ln_isfpar_mlt, cn_isfpar_mlt, sn_isfpar_fwf, sn_isfpar_zmin, sn_isfpar_zmax, sn_isfpar_Leff, &
+         &             ln_isfcpl    , nn_drown, ln_isfcpl_cons,                                                     &
+         &             cn_isfload   , cn_isfdir
       !!----------------------------------------------------------------------
       !
@@ -130,5 +137,5 @@
       !
       riceload(:,:)       = 0.0_wp
-      fwfisf_cpl(:,:)     = 0.0_wp
+      fwfisf_oasis(:,:)   = 0.0_wp
       fwfisf_par(:,:)     = 0.0_wp    ; fwfisf_par_b(:,:)     = 0.0_wp
       fwfisf_cav(:,:)     = 0.0_wp    ; fwfisf_cav_b(:,:)     = 0.0_wp
@@ -148,29 +155,40 @@
       IF(lwm) WRITE ( numond, namisf )
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'isf_init : ice shelf initialisation'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '   Namelist namisf :'
-      !
-      IF(lwp) WRITE(numout,*) '      melt inside the cavity                  ln_isfcav_mlt   = ', ln_isfcav_mlt
-      IF ( ln_isfcav ) THEN
-         IF(lwp) WRITE(numout,*) '         melt formulation                        cn_isfcav_mlt   = ', cn_isfcav_mlt
-         IF(lwp) WRITE(numout,*) '         thickness of the top boundary layer     rn_htbl     = ', rn_htbl
-         IF(lwp) WRITE(numout,*) '         gamma formulation                       cn_gammablk = ', cn_gammablk 
-         IF ( TRIM(cn_gammablk) .NE. 'spe' ) THEN 
-            IF(lwp) WRITE(numout,*) '            gammat coefficient                      rn_gammat0  = ', rn_gammat0  
-            IF(lwp) WRITE(numout,*) '            gammas coefficient                      rn_gammas0  = ', rn_gammas0  
-            IF(lwp) WRITE(numout,*) '            top drag coef. used (from namdrg_top)   rn_Cd0      = ', r_Cdmin_top 
-         END IF
-      END IF
-      !
-      IF(lwp) WRITE(numout,*) ''
-      !
-      IF(lwp) WRITE(numout,*) '      ice shelf melt parametrisation          ln_isfpar_mlt    = ', ln_isfpar_mlt
-      IF ( ln_isfpar_mlt ) THEN
-         IF(lwp) WRITE(numout,*) '         isf parametrisation formulation         cn_isfpar_mlt   = ', cn_isfpar_mlt
-      END IF
-      IF(lwp) WRITE(numout,*) ''
-      !
+      IF (lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'isf_init : ice shelf initialisation'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '   Namelist namisf :'
+         !
+         WRITE(numout,*) '      melt inside the cavity                  ln_isfcav_mlt   = ', ln_isfcav_mlt
+         IF ( ln_isfcav ) THEN
+            WRITE(numout,*) '         melt formulation                        cn_isfcav_mlt   = ', TRIM(cn_isfcav_mlt)
+            WRITE(numout,*) '         thickness of the top boundary layer     rn_htbl     = ', rn_htbl
+            WRITE(numout,*) '         gamma formulation                       cn_gammablk = ', TRIM(cn_gammablk) 
+            IF ( TRIM(cn_gammablk) .NE. 'spe' ) THEN 
+               WRITE(numout,*) '            gammat coefficient                      rn_gammat0  = ', rn_gammat0  
+               WRITE(numout,*) '            gammas coefficient                      rn_gammas0  = ', rn_gammas0  
+               WRITE(numout,*) '            top drag coef. used (from namdrg_top)   rn_Cd0      = ', r_Cdmin_top 
+            END IF
+         END IF
+         WRITE(numout,*) ''
+         !
+         WRITE(numout,*) '      ice shelf melt parametrisation          ln_isfpar_mlt    = ', ln_isfpar_mlt
+         IF ( ln_isfpar_mlt ) THEN
+            WRITE(numout,*) '         isf parametrisation formulation         cn_isfpar_mlt   = ', TRIM(cn_isfpar_mlt)
+         END IF
+         WRITE(numout,*) ''
+         !
+         WRITE(numout,*) '      Coupling to an ice sheet model          ln_isfcpl         = ', ln_isfcpl
+         IF ( ln_isfcpl ) THEN
+            WRITE(numout,*) '         conservation activated ln_isfcpl_cons           = ', ln_isfcpl_cons
+            WRITE(numout,*) '            number of call of the extrapolation loop = ', nn_drown
+         ENDIF
+         !
+         WRITE(numout,*) '      Ice shelf load method                   cn_isfload        = ', TRIM(cn_isfload)
+
+      END IF
+      !
+      !---------------------------------------------------------------------------------------------------------------------
       ! sanity check
       ! melt in the cavity without cavity
@@ -178,11 +196,14 @@
          &   CALL ctl_stop('ice shelf melt in the cavity activated (ln_isfcav_mlt) but no cavity detected in domcfg (ln_isfcav), STOP' )
       !
-      IF ( ln_cpl ) THEN
+      IF ( ln_isfcpl .AND. ln_isfcpl_cons .AND. ln_linssh ) &
+         &   CALL ctl_stop( 'The coupling between NEMO and an ice sheet model with the conservation option does not work with the linssh option' )
+      !
+      IF ( l_isfoasis ) THEN
          !
          CALL ctl_stop( ' ln_ctl and ice shelf not tested' )
          !
          ! NEMO coupled to ATMO model with isf cavity need oasis method for melt computation 
-         IF ( ln_isfcav_mlt .AND. TRIM(cn_isfcav_mlt) /= 'oasis' ) CALL ctl_stop( 'cn_isfcav_mlt = oasis is the only option availble with ln_cpl' )
-         IF ( ln_isfpar_mlt .AND. TRIM(cn_isfpar_mlt) /= 'oasis' ) CALL ctl_stop( 'cn_isfpar_mlt = oasis is the only option availble with ln_cpl' )
+         IF ( ln_isfcav_mlt .AND. TRIM(cn_isfcav_mlt) /= 'oasis' ) CALL ctl_stop( 'cn_isfcav_mlt = oasis is the only option availble if fwf send by oasis' )
+         IF ( ln_isfpar_mlt .AND. TRIM(cn_isfpar_mlt) /= 'oasis' ) CALL ctl_stop( 'cn_isfpar_mlt = oasis is the only option availble if fwf send by oasis' )
          !
          ! oasis melt computation not tested (coded but not tested)
@@ -198,4 +219,5 @@
       END IF
       !
+      !---------------------------------------------------------------------------------------------------------------------
       ! initialisation ice shelf load
       IF ( ln_isfcav ) THEN
@@ -212,4 +234,7 @@
       r1_Lfusisf =  1._wp / rLfusisf
       !
+      ll_isfcpl     = .FALSE.
+      ll_isfcpl_cons= .FALSE.
+      !
       ! initialisation melt in the cavity
       IF ( ln_isfcav_mlt ) THEN
@@ -223,4 +248,5 @@
       END IF
       !
+      !---------------------------------------------------------------------------------------------------------------------
       ! initialisation parametrised melt
       IF ( ln_isfpar_mlt ) THEN
@@ -234,4 +260,42 @@
       END IF
       !
+      !---------------------------------------------------------------------------------------------------------------------
+      ! initialisation ice sheet coupling
+      IF( ln_isfcpl ) THEN
+
+         ! prepare writing restart
+         IF( lwxios ) CALL iom_set_rstw_var_active('ssmask')
+         IF( lwxios ) CALL iom_set_rstw_var_active('tmask')
+         IF( lwxios ) CALL iom_set_rstw_var_active('e3t_n')
+         IF( lwxios ) CALL iom_set_rstw_var_active('e3u_n')
+         IF( lwxios ) CALL iom_set_rstw_var_active('e3v_n')
+
+         IF( ln_rstart ) THEN
+            !
+            ll_isfcpl = .TRUE.
+            !
+            CALL isf_alloc_cpl()
+            !
+            ! extrapolation tracer properties
+            CALL isfcpl_tra()
+            !
+            ! correction of the horizontal divergence and associated temp. and salt content flux
+            CALL isfcpl_vol()
+            !
+            ! apply the 'conservation' method
+            IF ( ln_isfcpl_cons )  THEN
+               ll_isfcpl_cons = .TRUE.
+               CALL isfcpl_cons()
+            END IF
+            !
+            ! Need to include in the cpl cons the isfrst_cpl_div contribution
+            ! decide how to manage thickness level change in conservation
+            !
+            tsb    (:,:,:,:) = tsn (:,:,:,:)
+            sshb   (:,:)     = sshn(:,:)
+            !
+         END IF
+      END IF
+         
   END SUBROUTINE isf_stp_init
    !!======================================================================
